From e577121892886b2ec262e857164beb61d2a43798 Mon Sep 17 00:00:00 2001
From: Aurelien Bompard <aurelien@bompard.org>
Date: Jan 31 2017 18:15:38 +0000
Subject: [PATCH 681/1001] Merge #306 `Python 3 compatibility for strings`


---

diff --git a/check-cache-coverage.py b/check-cache-coverage.py
index 0f6c6f7..a753f56 100755
--- a/check-cache-coverage.py
+++ b/check-cache-coverage.py
@@ -13,6 +13,8 @@ forcibly re-warms the cache.
 Authors:    Ralph Bean <rbean@redhat.com>
 """
 
+from __future__ import unicode_literals
+
 import sys
 import dogpile.cache
 
diff --git a/check-queue-length.py b/check-queue-length.py
index 4fc7098..5b14d0f 100755
--- a/check-queue-length.py
+++ b/check-queue-length.py
@@ -13,6 +13,8 @@ We could also graph this in collectd, for fun and profit.
 Authors:    Ralph Bean <rbean@redhat.com>
 """
 
+from __future__ import unicode_literals
+
 import fedmsg.config
 config = fedmsg.config.load_config()
 
diff --git a/delete-user.py b/delete-user.py
index acc2563..42a17c1 100755
--- a/delete-user.py
+++ b/delete-user.py
@@ -4,6 +4,8 @@
 Useful for testing what happens when you recreate them.
 """
 
+from __future__ import unicode_literals
+
 import sys
 
 import fedmsg.config
diff --git a/hubs/app.py b/hubs/app.py
index f352afd..89b5271 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -1,10 +1,11 @@
-from __future__ import print_function
+from __future__ import print_function, unicode_literals
 
 import datetime
 import functools
 import json
 import logging
 import os
+import six
 from six.moves.urllib import parse as urlparse
 
 import flask
@@ -454,7 +455,7 @@ def widget_source(name):
     fname = ''
 
     try:
-        fname = base + registry[name].__file__.split(base, 1)[1]
+        fname = base + registry[name].__file__.split(base)[-1]
     except KeyError:
         flask.abort(404)
 
@@ -546,7 +547,7 @@ def notifications(user):
         return flask.jsonify(notifications)
 
     if flask.request.method == 'POST':
-        data = json.loads(flask.request.data)
+        data = flask.request.get_json()
         user = hubs.models.User.by_username(session, user)
         if not user:
             return flask.abort(400)
@@ -756,7 +757,7 @@ def plus_plus_status(user):
 def plus_plus_update_bool_helper(val):
     if isinstance(val, bool):
         return val
-    elif isinstance(val, (str, unicode)):
+    elif isinstance(val, six.string_types):
         fmt_str = str(val).replace("'", "").replace('"', '').lower()
         return fmt_str in ("yes", "true", "t", "1")
     else:
diff --git a/hubs/backend/consumer.py b/hubs/backend/consumer.py
index 9d73ef1..7ea5083 100755
--- a/hubs/backend/consumer.py
+++ b/hubs/backend/consumer.py
@@ -1,5 +1,7 @@
 # The fedora hubs backend daemon
 
+from __future__ import unicode_literals
+
 import fedmsg.consumers
 import fedmsg.meta
 
diff --git a/hubs/backend/triage.py b/hubs/backend/triage.py
index ad86221..c1bf1da 100755
--- a/hubs/backend/triage.py
+++ b/hubs/backend/triage.py
@@ -19,6 +19,8 @@ though.  If they see that invalidation is required, they put a new task on an
 handle.
 """
 
+from __future__ import unicode_literals
+
 import hubs.app
 import hubs.models
 
diff --git a/hubs/backend/worker.py b/hubs/backend/worker.py
index 11c3342..abc1b32 100755
--- a/hubs/backend/worker.py
+++ b/hubs/backend/worker.py
@@ -24,6 +24,8 @@ another redis queue so that an EventSource server can update any connected web
 clients with the new content produced here.
 """
 
+from __future__ import unicode_literals
+
 import hubs.app
 import hubs.models
 
diff --git a/hubs/default_config.py b/hubs/default_config.py
index bb9ef80..769f8ad 100755
--- a/hubs/default_config.py
+++ b/hubs/default_config.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import os
 
 SECRET_KEY = 'changemeforreal'
diff --git a/hubs/defaults.py b/hubs/defaults.py
index 2a27612..d91d452 100755
--- a/hubs/defaults.py
+++ b/hubs/defaults.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import json
 
 import hubs.models
diff --git a/hubs/hinting.py b/hubs/hinting.py
index 14ed445..b1a8c2f 100755
--- a/hubs/hinting.py
+++ b/hubs/hinting.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import decorator
 
 import fedmsg.config
diff --git a/hubs/models.py b/hubs/models.py
index add289e..cdc02de 100755
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -20,6 +20,7 @@
 # of Red Hat, Inc.
 #
 
+from __future__ import unicode_literals
 
 import datetime
 import json
diff --git a/hubs/stream.py b/hubs/stream.py
index fd45923..ced01b9 100644
--- a/hubs/stream.py
+++ b/hubs/stream.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import json
 import os
 
diff --git a/hubs/tests/__init__.py b/hubs/tests/__init__.py
index 2fd805c..7f8aa8c 100644
--- a/hubs/tests/__init__.py
+++ b/hubs/tests/__init__.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from contextlib import contextmanager
 import json
 from datetime import datetime, timedelta
diff --git a/hubs/tests/test_api/test_hub.py b/hubs/tests/test_api/test_hub.py
index 815411d..821746c 100644
--- a/hubs/tests/test_api/test_hub.py
+++ b/hubs/tests/test_api/test_hub.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import flask
 import unittest
 from six.moves.urllib.parse import urlparse
diff --git a/hubs/tests/test_api/test_notifications.py b/hubs/tests/test_api/test_notifications.py
index 8440baf..5b8ad9e 100644
--- a/hubs/tests/test_api/test_notifications.py
+++ b/hubs/tests/test_api/test_notifications.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import json
 from six.moves.urllib.parse import urlparse
 
@@ -15,7 +17,7 @@ class TestGetNotifications(hubs.tests.APPTest):
         with hubs.tests.auth_set(app, self.user):
             resp = self.app.get('/{}/notifications/'.format(name))
         self.assertEqual(resp.status_code, 200)
-        data = json.loads(resp.data)
+        data = json.loads(resp.get_data(as_text=True))
         self.assertEqual(data, [])
 
     def test_get_notifications_valid_name(self):
@@ -24,7 +26,7 @@ class TestGetNotifications(hubs.tests.APPTest):
                 self.user.username))
 
         self.assertEqual(resp.status_code, 200)
-        data = json.loads(resp.data)
+        data = json.loads(resp.get_data(as_text=True))
         self.assertEqual(len(data), 1)
 
         for saved in data:
@@ -50,24 +52,27 @@ class TestPostNotifications(hubs.tests.APPTest):
         with hubs.tests.auth_set(app, self.user):
             resp = self.app.post(
                 '/{}/notifications/'.format('notarealfasuser'),
-                data=json.dumps(self.valid_payload))
+                data=json.dumps(self.valid_payload),
+                content_type='application/json')
         self.assertEqual(resp.status_code, 400)
 
     def test_post_notification_invalid_payload(self):
         with hubs.tests.auth_set(app, self.user):
             resp = self.app.post(
                 '/{}/notifications/'.format(self.user.username),
-                data=json.dumps(self.invalid_payload))
+                data=json.dumps(self.invalid_payload),
+                content_type='application/json')
         self.assertEqual(resp.status_code, 400)
 
     def test_post_notification_valid_payload(self):
         with hubs.tests.auth_set(app, self.user):
             resp = self.app.post(
                 '/{}/notifications/'.format(self.user.username),
-                data=json.dumps(self.valid_payload))
+                data=json.dumps(self.valid_payload),
+                content_type='application/json')
 
         self.assertEqual(resp.status_code, 200)
-        data = json.loads(resp.data)
+        data = json.loads(resp.get_data(as_text=True))
         self.assertTrue(isinstance(data, dict))
 
         notification = data['notification']
diff --git a/hubs/tests/test_fedora_hubs_flask_api.py b/hubs/tests/test_fedora_hubs_flask_api.py
index ea4b6b9..3c24905 100644
--- a/hubs/tests/test_fedora_hubs_flask_api.py
+++ b/hubs/tests/test_fedora_hubs_flask_api.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import unittest
 from six.moves.urllib.parse import urlparse
 import ast # import for string to dict conversion without unicode
@@ -32,17 +34,19 @@ class HubsAPITest(hubs.tests.APPTest):
             # its trying to redirect to login id.fedoraproject.org/openid
             # assert the status code of the response
             self.assertEqual(result.status_code, 200)
-            self.assertFalse('Not logged in.  Click to <a href="'
-                             '/login">login</a>' in result.data)
+            self.assertNotIn(
+                'Not logged in.  Click to <a href="/login">login</a>',
+                result.get_data(as_text=True))
 
     def test_hub_logged_out(self):
         with tests.auth_set(app, None):  # check_auth doesn't load in unittest
             result = self.app.get('/ralph', follow_redirects=True)
             self.assertEqual(result.status_code, 200)
             match_expected = r'<h5[^>]*>Ralph</h5>'
-            self.assertRegexpMatches(result.data, match_expected)
+            self.assertRegexpMatches(
+                result.get_data(as_text=True), match_expected)
             str_expected = 'Not logged in.'
-            self.assertTrue(str_expected in result.data)
+            self.assertIn(str_expected, result.get_data(as_text=True))
 
     def test_groups_logged_out(self):
         result = self.app.get('/groups', follow_redirects=False)
@@ -57,15 +61,17 @@ class HubsAPITest(hubs.tests.APPTest):
             result = self.app.get('/groups', follow_redirects=True)
             # assert the status code of the response
             self.assertEqual(result.status_code, 200)
-            self.assertTrue("ZOMG -  is the Hub Of The Month!" in result.data)
+            self.assertIn("ZOMG -  is the Hub Of The Month!",
+                          result.get_data(as_text=True))
 
     def test_hub_logged_in(self):
         user = tests.FakeAuthorization('ralph')
         with tests.auth_set(app, user):
             result = self.app.get('/ralph', follow_redirects=True)
             self.assertEqual(result.status_code, 200)
-            self.assertFalse('Not logged in.  Click to <a href="'
-                             '/login">login</a>' in result.data)
+            self.assertNotIn(
+                'Not logged in.  Click to <a href="/login">login</a>',
+                result.get_data(as_text=True))
 
     def test_hub_json(self):
         result = self.app.get('/ralph/json', follow_redirects=True)
@@ -83,7 +89,7 @@ class HubsAPITest(hubs.tests.APPTest):
             "summary": "Ralph",
             "widgets": [34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 56]
         }
-        self.assertDictEqual(data, ast.literal_eval(result.data))
+        self.assertDictEqual(data, json.loads(result.get_data(as_text=True)))
 
     @unittest.skip("Authorization layer not present yet")
     def test_hub_edit_get_logged_out(self):
@@ -132,10 +138,12 @@ class HubsAPITest(hubs.tests.APPTest):
             result = self.app.post('/ralph/edit', data={},
                                    follow_redirects=True)
             self.assertEqual(result.status_code, 200)
-            self.assertFalse('Not logged in.  Click to <a href="'
-                             '/login">login</a>' in result.data)
-            self.assertTrue('<a href="#" class="dropdown-item">Full Name: '
-                            'fullname: ralph</a>' in result.data)
+            self.assertNotIn(
+                'Not logged in.  Click to <a href="/login">login</a>',
+                result.get_data(as_text=True))
+            self.assertIn(
+                '<a href="#" class="dropdown-item">Full Name: '
+                'fullname: ralph</a>', result.get_data(as_text=True))
 
     def test_hub_edit_post_logged_in_owner_valid_data(self):
         user = tests.FakeAuthorization('ralph')
@@ -156,7 +164,7 @@ class HubsAPITest(hubs.tests.APPTest):
             result = self.app.post('/ralph/edit', data=data,
                                    follow_redirects=True)
             self.assertEqual(result.status_code, 200)
-            self.assertEqual(result.data, 'ok')
+            self.assertEqual(result.get_data(as_text=True), 'ok')
 
     def test_hub_edit_post_logged_in_owner_invalid_data_1(self):
         user = tests.FakeAuthorization('ralph')
@@ -211,30 +219,30 @@ class HubsAPITest(hubs.tests.APPTest):
         result = self.app.get('/ralph/add', follow_redirects=False)
         self.assertEqual(result.status_code, 400)
         expected_str = 'Invalid position provided'
-        self.assertTrue(expected_str in result.data)
+        self.assertIn(expected_str, result.get_data(as_text=True))
 
     def test_hub_add_widget_get_with_args(self):
         result = self.app.get('/ralph/add?position=right',
                               follow_redirects=True)
         self.assertEqual(result.status_code, 200)
         expected_str = 'Adding widget to hub: ralph'
-        self.assertTrue(expected_str in result.data)
+        self.assertIn(expected_str, result.get_data(as_text=True))
         expected_str = "url: 'add/' + $('#widget').val() + '?position=right',"
-        self.assertTrue(expected_str in result.data)
+        self.assertIn(expected_str, result.get_data(as_text=True))
 
     def test_hub_add_widget_post_no_widget_name(self):
         data = {}
         result = self.app.post('/ralph/add', data=data, follow_redirects=False)
         self.assertEqual(result.status_code, 400)
         expected_str = 'Invalid request sent'
-        self.assertTrue(expected_str in result.data)
+        self.assertIn(expected_str, result.get_data(as_text=True))
 
     def test_hub_add_widget_post_invalid_widget_name(self):
         data = {'widget_name': 'invalid_widget_name'}
         result = self.app.post('/ralph/add', data=data, follow_redirects=False)
         self.assertEqual(result.status_code, 404)
         expected_str = 'Unknown widget called'
-        self.assertTrue(expected_str in result.data)
+        self.assertIn(expected_str, result.get_data(as_text=True))
 
     def test_hub_add_widget_post_valid_widget_name_no_args(self):
         user = tests.FakeAuthorization('ralph')
@@ -244,9 +252,9 @@ class HubsAPITest(hubs.tests.APPTest):
                                    follow_redirects=False)
             self.assertEqual(result.status_code, 200)
             expected_str = '<h6 class="dropdown-header">Account Information</h6>'
-            self.assertTrue(expected_str in result.data)
+            self.assertIn(expected_str, result.get_data(as_text=True))
             expected_str = '<a href="#" class="dropdown-item">Full Name: fullname: ralph</a>'
-            self.assertTrue(expected_str in result.data)
+            self.assertIn(expected_str, result.get_data(as_text=True))
 
     def test_hub_add_widget_post_valid_widget_name_with_args(self):
         user = tests.FakeAuthorization('ralph')
@@ -256,9 +264,9 @@ class HubsAPITest(hubs.tests.APPTest):
                                    follow_redirects=False)
             self.assertEqual(result.status_code, 200)
             expected_str = '<h6 class="dropdown-header">Account Information</h6>'
-            self.assertTrue(expected_str in result.data)
+            self.assertIn(expected_str, result.get_data(as_text=True))
             expected_str = '<a href="#" class="dropdown-item">Full Name: fullname: ralph</a>'
-            self.assertTrue(expected_str in result.data)
+            self.assertIn(expected_str, result.get_data(as_text=True))
 
     def test_hub_edit_widget_get_logged_in(self):
         user = tests.FakeAuthorization('ralph')
@@ -266,7 +274,7 @@ class HubsAPITest(hubs.tests.APPTest):
             result = self.app.get('/ralph/37/edit', follow_redirects=True)
             self.assertEqual(result.status_code, 200)
             expected_str = '/ralph/37/edit'
-            self.assertTrue(expected_str in result.data)
+            self.assertIn(expected_str, result.get_data(as_text=True))
 
     @unittest.skip("Authorization layer not present yet")
     def test_hub_edit_widget_get_logged_out(self):
@@ -287,10 +295,14 @@ class HubsAPITest(hubs.tests.APPTest):
         with tests.auth_set(app, user):
             url = '/visit/decause'
             result = self.app.get(url)
-            self.assertEqual(json.loads(result.data), {"count": 0})
+            self.assertEqual(
+                json.loads(result.get_data(as_text=True)),
+                {"count": 0})
 
             result = self.app.post(url)
-            self.assertEqual(json.loads(result.data), {"count": 1})
+            self.assertEqual(
+                json.loads(result.get_data(as_text=True)),
+                {"count": 1})
 
             # accessing my hub shouldn't increment the count
             url = 'visit/ralph'
@@ -313,21 +325,22 @@ class HubsAPITest(hubs.tests.APPTest):
         with tests.auth_set(app, user):
             url = '/visit/decause'
             result = self.app.get(url)
-            self.assertEqual(result.data, '0')
+            self.assertEqual(result.get_data(as_text=True), '0')
 
             url = '/decause'
             result = self.app.get(url, follow_redirects=True)
 
             url = '/visit/decause'
             result = self.app.get(url)
-            self.assertEqual(result.data, '1')
+            self.assertEqual(result.get_data(as_text=True), '1')
 
     def test_hub_add_widget_valid_side(self):
         user = tests.FakeAuthorization('ralph')
         with tests.auth_set(app, user):
             url = '/ralph/add/about?position=right'
             result = self.app.get(url)
-            self.assertTrue('Adding widget "about"to hub: ralph' in result.data)
+            self.assertIn('Adding widget "about"to hub: ralph',
+                          result.get_data(as_text=True))
 
     def test_hub_add_widget_invalid_side(self):
         user = tests.FakeAuthorization('ralph')
@@ -342,7 +355,7 @@ class HubsAPITest(hubs.tests.APPTest):
             url = '/ralph/37/delete'  # 37 is widget fedmsgstats for ralph
             result = self.app.post(url)
             self.assertEqual(result.status_code, 302)
-            self.assertTrue('/ralph/edit' in result.data)
+            self.assertIn('/ralph/edit', result.get_data(as_text=True))
 
     def test_source_name(self):
         with tests.auth_set(app, None):
@@ -351,7 +364,7 @@ class HubsAPITest(hubs.tests.APPTest):
             self.assertEqual(result.status_code, 302)
             expected_str = 'https://pagure.io/fedora-hubs/' \
                            'blob/develop/f/hubs/widgets/about.py'
-            self.assertTrue(expected_str in result.data)
+            self.assertIn(expected_str, result.get_data(as_text=True))
 
     def test_source_name_not_existent(self):
         with tests.auth_set(app, None):
@@ -415,7 +428,9 @@ class HubsAPITest(hubs.tests.APPTest):
             "total": 0,
             "username": "decause"
         }
-        self.assertEqual(json.loads(result.data), expected)
+        self.assertEqual(
+            json.loads(result.get_data(as_text=True)),
+            expected)
 
     @mock.patch('requests.post', side_effect=mocked_requests_post)
     def test_plus_plus_post_increment_valid(self, mock_post):
@@ -431,7 +446,9 @@ class HubsAPITest(hubs.tests.APPTest):
                 "total": 1,
                 "username": "decause"
             }
-            self.assertEqual(json.loads(result.data), expected)
+            self.assertEqual(
+                json.loads(result.get_data(as_text=True)),
+                expected)
 
     @mock.patch('requests.post', side_effect=mocked_requests_post)
     def test_plus_plus_post_increment_myself_error(self, mock_post):
@@ -440,7 +457,9 @@ class HubsAPITest(hubs.tests.APPTest):
             url = '/plus_plus/ralph/update'
             result = self.app.post(url, data={'increment': True})
             self.assertEqual(result.status_code, 403)
-            self.assertEqual(result.data, 'You may not modify your own karma.')
+            self.assertEqual(
+                result.get_data(as_text=True),
+                'You may not modify your own karma.')
 
     @mock.patch('requests.post', side_effect=mocked_requests_post)
     def test_plus_plus_post_increment_user_does_not_exist(self, mock_post):
@@ -449,7 +468,9 @@ class HubsAPITest(hubs.tests.APPTest):
             url = '/plus_plus/doesnotexist/update'
             result = self.app.post(url, data={'increment': True})
             self.assertEqual(result.status_code, 403)
-            self.assertEqual(result.data, 'User does not exist')
+            self.assertEqual(
+                result.get_data(as_text=True),
+                'User does not exist')
 
     @mock.patch('requests.post', side_effect=mocked_requests_post)
     def test_plus_plus_post_increment_no_data_error(self, mock_post):
@@ -460,13 +481,13 @@ class HubsAPITest(hubs.tests.APPTest):
             self.assertEqual(result.status_code, 403)
             exp_str = "You must set 'decrement' or 'increment' " \
                       "with a boolean value in the body"
-            self.assertEqual(result.data, exp_str)
+            self.assertEqual(result.get_data(as_text=True), exp_str)
 
     def test_plus_plus_receiver_does_not_exist(self):
         url = '/plus_plus/doesnotexist/status'
         result = self.app.get(url)
         self.assertEqual(result.status_code, 403)
-        self.assertEqual(result.data, 'User does not exist')
+        self.assertEqual(result.get_data(as_text=True), 'User does not exist')
 
 
 
diff --git a/hubs/tests/test_models.py b/hubs/tests/test_models.py
index 93f4a31..3065cfb 100644
--- a/hubs/tests/test_models.py
+++ b/hubs/tests/test_models.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import hubs
 import hubs.models
 import hubs.tests
diff --git a/hubs/tests/test_widgets/__init__.py b/hubs/tests/test_widgets/__init__.py
index 9b9ac69..47a2f4f 100644
--- a/hubs/tests/test_widgets/__init__.py
+++ b/hubs/tests/test_widgets/__init__.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import json
 from datetime import datetime, timedelta
 from os.path import dirname
diff --git a/hubs/tests/test_widgets/test_about.py b/hubs/tests/test_widgets/test_about.py
index f67e476..74e0c56 100644
--- a/hubs/tests/test_widgets/test_about.py
+++ b/hubs/tests/test_widgets/test_about.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import json
 
 from nose.tools import assert_dict_equal
@@ -12,7 +14,7 @@ class TestBadges(hubs.tests.test_widgets.WidgetTest):
         widget = self.widget_instance('ralph', self.plugin)
         response = self.app.get('/ralph/%i/json/' % widget.idx)
         assert response.status_code == 200, response.status_code
-        data = json.loads(response.data)
+        data = json.loads(response.get_data(as_text=True))
         del data['data']['widget_url']
         self.assertDictEqual(data['data'], {
             u'edit_url': u'/ralph/56/edit',
diff --git a/hubs/tests/test_widgets/test_badges.py b/hubs/tests/test_widgets/test_badges.py
index b3b5197..8a88807 100644
--- a/hubs/tests/test_widgets/test_badges.py
+++ b/hubs/tests/test_widgets/test_badges.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import json
 
 from mock import patch, MagicMock
@@ -11,7 +13,7 @@ class TestBadges(hubs.tests.test_widgets.WidgetTest):
         widget = self.widget_instance('ralph', self.plugin)
         response = self.app.get('/ralph/%i/json/' % widget.idx)
         assert response.status_code == 200, response.status_code
-        data = json.loads(response.data)
+        data = json.loads(response.get_data(as_text=True))
         self.assertEquals(data['plugin'], 'badges')
         self.assertIn('assertions', data['data'].keys())
 
@@ -45,4 +47,4 @@ class TestBadges(hubs.tests.test_widgets.WidgetTest):
         msg = {'topic': 'hubs.widget.update', 'msg': {'widget': {'id': widget.idx + 1}}}
         module = hubs.widgets.registry[widget.plugin]
         result = module.should_invalidate(msg, self.session, widget)
-        self.assertTrue(result)
\ No newline at end of file
+        self.assertTrue(result)
diff --git a/hubs/tests/test_widgets/test_fedmsgstats.py b/hubs/tests/test_widgets/test_fedmsgstats.py
index c88b7a4..0d7e79d 100644
--- a/hubs/tests/test_widgets/test_fedmsgstats.py
+++ b/hubs/tests/test_widgets/test_fedmsgstats.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import json
 
 import hubs.tests.test_widgets
@@ -10,7 +12,7 @@ class TestFedmsgStats(hubs.tests.test_widgets.WidgetTest):
         widget = self.widget_instance('ralph', self.plugin)
         response = self.app.get('/ralph/%i/json/' % widget.idx)
         assert response.status_code == 200, response.status_code
-        data = json.loads(response.data)
+        data = json.loads(response.get_data(as_text=True))
         del data['data']['widget_url']
         self.assertDictEqual(data['data'], {
             u'edit_url': u'/ralph/37/edit',
diff --git a/hubs/tests/test_widgets/test_library.py b/hubs/tests/test_widgets/test_library.py
index bd01019..9182b56 100644
--- a/hubs/tests/test_widgets/test_library.py
+++ b/hubs/tests/test_widgets/test_library.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import json
 
 import hubs.tests.test_widgets
@@ -10,7 +12,7 @@ class TestLibrary(hubs.tests.test_widgets.WidgetTest):
         widget = self.widget_instance('ralph', self.plugin)
         response = self.app.get('/ralph/%i/json/' % widget.idx)
         self.assertEqual(response.status_code, 200)
-        data = json.loads(response.data)
+        data = json.loads(response.get_data(as_text=True))
         expected_dict = {
             "config": {
                 "urls": "ralph/"
diff --git a/hubs/tests/test_widgets/test_meetings.py b/hubs/tests/test_widgets/test_meetings.py
index 7184796..08ea046 100644
--- a/hubs/tests/test_widgets/test_meetings.py
+++ b/hubs/tests/test_widgets/test_meetings.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import json
 
 import hubs.tests.test_widgets
@@ -11,7 +13,7 @@ class TestMeetings(hubs.tests.test_widgets.WidgetTest):
         widget = self.widget_instance(team, self.plugin)
         response = self.app.get('/%s/%i/json/' % (team, widget.idx))
         self.assertEqual(200, response.status_code)
-        data = json.loads(response.data)
+        data = json.loads(response.get_data(as_text=True))
         calendar_name = data['data']['calendar']
         self.assertIn(team, calendar_name)
 
@@ -20,5 +22,6 @@ class TestMeetings(hubs.tests.test_widgets.WidgetTest):
         widget = self.widget_instance(team, self.plugin)
         response = self.app.get('/%s/%i/' % (team, widget.idx))
         self.assertEqual(200, response.status_code)
-        self.assertIn('i18n', response.data)
-        self.assertIn('<strong>Request A New Meeting</strong>', response.data)
\ No newline at end of file
+        self.assertIn('i18n', response.get_data(as_text=True))
+        self.assertIn('<strong>Request A New Meeting</strong>',
+                      response.get_data(as_text=True))
diff --git a/hubs/utils.py b/hubs/utils.py
index ed00d80..f1ecd92 100755
--- a/hubs/utils.py
+++ b/hubs/utils.py
@@ -1,9 +1,13 @@
+from __future__ import unicode_literals
+
+import json
 import logging
 from hashlib import sha256
 
 import arrow
 import markdown
 import requests
+import six
 
 from six.moves.urllib_parse import urlencode
 
@@ -18,10 +22,7 @@ def markup(text):
 
 
 def username2avatar(username, s=312):
-    query = urlencode({
-        'd': 'retro',
-        's': s,
-    })
+    query = urlencode([('s', s), ('d', 'retro')])
     openid = 'http://%s.id.fedoraproject.org/' % username
     hash = sha256(openid.encode('utf-8')).hexdigest()
     avatar = "https://seccdn.libravatar.org/avatar/%s?%s" % (hash, query)
diff --git a/hubs/validators.py b/hubs/validators.py
index 2ae918f..302b0e7 100755
--- a/hubs/validators.py
+++ b/hubs/validators.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import kitchen.text.converters
 
 import hubs.models
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 5f416ed..95253e7 100755
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from hubs.widgets import dummy
 from hubs.widgets import stats
 from hubs.widgets import rules
diff --git a/hubs/widgets/about.py b/hubs/widgets/about.py
index 4be594c..7f0d994 100755
--- a/hubs/widgets/about.py
+++ b/hubs/widgets/about.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from hubs.hinting import hint, prefixed as _
 from hubs.widgets.chrome import panel
 from hubs.widgets.base import argument
diff --git a/hubs/widgets/badges.py b/hubs/widgets/badges.py
index abf4b15..86bc929 100755
--- a/hubs/widgets/badges.py
+++ b/hubs/widgets/badges.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import operator
 
 import requests
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index f3cf198..581532e 100755
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import collections
 import datetime
 import functools
diff --git a/hubs/widgets/bugzilla.py b/hubs/widgets/bugzilla.py
index a33e318..c2d94ae 100644
--- a/hubs/widgets/bugzilla.py
+++ b/hubs/widgets/bugzilla.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import requests
 import pkgwat.api
 
diff --git a/hubs/widgets/chrome.py b/hubs/widgets/chrome.py
index 717e047..b869094 100755
--- a/hubs/widgets/chrome.py
+++ b/hubs/widgets/chrome.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from hubs.widgets.base import wraps
 from hubs.widgets import templating
 
diff --git a/hubs/widgets/clean_input.py b/hubs/widgets/clean_input.py
index 2ec458a..9d25104 100644
--- a/hubs/widgets/clean_input.py
+++ b/hubs/widgets/clean_input.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from six.moves.urllib.parse import urlparse
 
 import bleach
diff --git a/hubs/widgets/contact.py b/hubs/widgets/contact.py
index b76873c..b14e126 100644
--- a/hubs/widgets/contact.py
+++ b/hubs/widgets/contact.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 import flask
 
 import fedmsg.config
diff --git a/hubs/widgets/dummy.py b/hubs/widgets/dummy.py
index 2e73bca..bd198d3 100755
--- a/hubs/widgets/dummy.py
+++ b/hubs/widgets/dummy.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from hubs.hinting import hint, prefixed as _
 from hubs.widgets.chrome import panel
 from hubs.widgets.base import argument
diff --git a/hubs/widgets/fedmsgstats.py b/hubs/widgets/fedmsgstats.py
index 533c563..0cf5ba2 100755
--- a/hubs/widgets/fedmsgstats.py
+++ b/hubs/widgets/fedmsgstats.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from hubs.hinting import hint
 from hubs.widgets.chrome import panel
 from hubs.widgets import templating
diff --git a/hubs/widgets/feed.py b/hubs/widgets/feed.py
index 8ea6536..5d744d9 100755
--- a/hubs/widgets/feed.py
+++ b/hubs/widgets/feed.py
@@ -1,4 +1,4 @@
-from __future__ import print_function
+from __future__ import print_function, unicode_literals
 
 from hubs.hinting import hint
 from hubs.widgets.base import argument
diff --git a/hubs/widgets/fhosted.py b/hubs/widgets/fhosted.py
index 827b228..bc97d8b 100644
--- a/hubs/widgets/fhosted.py
+++ b/hubs/widgets/fhosted.py
@@ -1,3 +1,5 @@
+from __future__ import unicode_literals
+
 from six.moves.xmlrpc_client import ServerProxy
 
 import hubs.validators as validators
